/* bzflag
 * Copyright (c) 1993 - 2005 Tim Riker
 *
 * This package is free software; you can redistribute it and/or
 * modify it under the terms of the license found in the file
 * named COPYING that should have accompanied this file.
 *
 * THIS PACKAGE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "common.h"

#include <string>
#include <vector>

#include "CronJob.h"
#include "bzfsAPI.h"
#include "SynchroServerLink.h"

// -- Event handler class

class CronManager : public bz_EventHandler {
public:
  CronManager();
  ~CronManager();

  void process(bz_EventData *eventData);
  bool autoDelete(void) {return false;};

  bool connect();
  bool connect2();
  bool connect3();
  void sendMessage(std::string message);

  void addJob(CronJob &job) {jobs.push_back(job);};
  void clearJobs() {jobs.clear();};

  void setCrontab(std::string _crontab) {this->crontab = _crontab;};
  bool reload();
  void list(int playerID) const;

private:
  std::vector<CronJob> jobs;
  double lastTick;
  int lastMinute;
  std::string crontab;

  double startupTime;
  double stageTime;
  int stage;

  int cronID;
  void getNet();
  ServerLink* sLink;
};

extern CronManager cron;
extern int debugLevel;
